﻿using System;
using Telerik.XamarinForms.Common;
using Telerik.XamarinForms.DataControls.ListView;
using Xamarin.Forms;

namespace XFLView
{
    public partial class MainPage : ContentPage
    {
        public MainPage()
        {
            InitializeComponent();
            listView.BindingContext = new ViewModel();

           
            //listView.SortDescriptors.Add(new Telerik.XamarinForms.DataControls.ListView.PropertySortDescriptor { PropertyName = "Address.City", SortOrder = SortOrder.Descending });
        }

        private int NestedPropertyComparer(object arg1, object arg2)
        {
            var item1 = arg1 as Person;
            var item2 = arg2 as Person;
            var city1 = item1?.Address?.City;
            var city2 = item2?.Address?.City;

            return string.Compare(city1, city2);
        }

        private int AgeComparer(object arg1, object arg2)
        {
            // TODO: Handle null values here somehow
            var item1 = (arg1 as Person).Age.GetValueOrDefault();
            var item2 = (arg2 as Person).Age.GetValueOrDefault();

            return item1.CompareTo(item2);
        }

        private void Button_Clicked(object sender, EventArgs e)
        {
            this.listView.SortDescriptors.Clear();
            this.listView.SortDescriptors.Add(new PropertySortDescriptor() { PropertyName = "Name", SortOrder = SortOrder.Descending});
        }

        private void Button_Clicked_1(object sender, EventArgs e)
        {
            var delegateSortDescriptor = new DelegateSortDescriptor
            {
                Comparer = AgeComparer,
                SortOrder = SortOrder.Descending
            };
            this.listView.SortDescriptors.Clear();
            this.listView.SortDescriptors.Add(delegateSortDescriptor);
        }

        private void Button_Clicked_2(object sender, EventArgs e)
        {
            var delegateSortDescriptor = new DelegateSortDescriptor
            {
                Comparer = NestedPropertyComparer,
                SortOrder = SortOrder.Descending
            };
            this.listView.SortDescriptors.Clear();
            this.listView.SortDescriptors.Add(delegateSortDescriptor);
        }
    }
}
